#coding:UTF-8
#!/usr/bin/env python

from Tkinter import *
import ScrolledText as S #importの時、S.**で起動可能
import datetime
import threading
import os
import popen2
import tkFileDialog as D

############################
#  start condition
#  
############################

def today_stamp():
	today = datetime.datetime.today()
	data = "		" + today.strftime("%Y/%m/%d %H:%M:%S")+"\n"
	app.textbox.insert(END,data)

def savedirname_stamp():
	f = open("./setup/SaveFileName.txt","r")
	dirname = f.readline()
	app.textbox.insert(END,"保存先: ")
	app.textbox.insert(END,dirname)
	f.close()

def PreAmpHG_stamp():
	f = open("./setup/HGPAFback1.txt","r")
	for i in range(8):
		f.readline()
	for i in range(3):
		f.read(2)
	a = int(f.read(1))
	f.close()
	gain = ["150","75","50","37.5","30","15"]
	b=0
	for i in [8,4,12,2,10,6]:
		if a == i:
			break
		b+=1
	if a == i:
		HG = gain[b]
#		app.textbox.insert(END,"内蔵PreAmp(HG): ")
		app.textbox.insert(END,"   ")
		app.textbox.insert(END,HG)
		app.textbox.insert(END,", ")
	else:
#		app.textbox.insert(END,"内蔵PreAmp(HG):---\n")
		app.textbox.insert(END,"---")

def PreAmpLG_stamp():
	f = open("./setup/LGPAFback1.txt","r")
	for i in range(8):
		f.readline()
	for i in range(3):
		f.read(2)
	a = int(f.read(1))
	f.close()
	gain = ["15","7.5","5.0","3.75","3.0","1.5"]
	b=0
	for i in [8,4,12,2,10,6]:
		if a == i:
			break
		b+=1
	if a == i:
		LG = gain[b]
#		app.textbox.insert(END,"内蔵PreAmp(LG): ")
		app.textbox.insert(END,LG)
		app.textbox.insert(END,", ")
	else:
#		app.textbox.insert(END,"内蔵PreAmp(LG):---\n")
		app.textbox.insert(END,"--- ")

def SSh_stamp():
	f = open("./setup/TimeCHGSSh1.txt","r")
	for i in range(8):
		f.readline()
	for i in range(3):
		f.read(2)
	a = int(f.read(1))
	f.close()
	SSh = ["25ns","50ns","75ns","100ns","125ns","150ns","175ns"]
	b=0
	for i in [3,5,1,6,2,4,0]:
		if a == i:
			break
		b+=1
	if a == i:
		t_coeff = SSh[b]
#		app.textbox.insert(END,"SSH 時定数: ")
		app.textbox.insert(END,t_coeff)
		app.textbox.insert(END,"\n")
	else:
#		app.textbox.insert(END,"SSH 時定数:---\n")
		app.textbox.insert(END,"---\n")


def init_sys():
	app.textbox.insert(END,"****************************\n")
	app.textbox.insert(END,"- EASIROC & CAMAC DAQ -\n")
	app.textbox.insert(END,"       WELCOME\n")
	app.textbox.insert(END,"****************************\n")
	savedirname_stamp()
	app.textbox.insert(END,"EASIROC parameter:\n")
	app.textbox.insert(END,"   HG, LG, SSh-t\n")
	PreAmpHG_stamp()
	PreAmpLG_stamp()
	SSh_stamp()
	today_stamp()


#oooooooo0000000000000000ooooooooooooo0000000000ooooooooo00000000000oooooooooo
##########################
#
# GUI class configuration
#
##########################
class App(Frame):
	def init(self):

##文字列定義
#		buff1 = StringVar()
#		buff2 = StringVar()
#		buff3 = StringVar()
#		buff4 = StringVar()
#		buff5 = StringVar()
#		buff6 = StringVar()

#		buff1.set("保存先:　　　　　　　　　　　　　　　　")
#		f = open("./setup/SaveFileName.txt","r")
#		dirname = f.readline()
#		print dirname
#		buff2.set(dirname)
#		f.close()
#		buff3.set("filename: ")
#		buff4.set("")
#		buff5.set("")
#		buff6.set("")




##オブジェクト定義
#		self.label = Label(self,text='',fg='blue')
#		self.l_par1 = Label(self,textvariable=buff1,fg='blue')
#		self.l_par2 = Label(self,textvariable=buff2,fg='blue')
#		self.l_par3 = Label(self,textvariable=buff3,fg='blue')
#		self.l_par4 = Label(self,textvariable=buff4,fg='blue')
#		self.l_par5 = Label(self,textvariable=buff5,fg='blue')
#		self.l_par6 = Label(self,textvariable=buff6,fg='blue')
		self.bstart = Button(self,text='Start')
		self.bstop = Button(self,text='Stop')
		self.bquit = Button(self, text='Quit', command=self.exit)
		self.textbox = S.ScrolledText(self, width=40, height=10)


###メニュー
		menu_bar = Menu(self)
		self.master.config(menu=menu_bar)
###メニューバー生成
		menu_file = Menu(menu_bar, tearoff=0)
		menu_edit = Menu(menu_bar, tearoff=0)
		menu_search = Menu(menu_bar, tearoff=0)
		menu_help = Menu(menu_bar, tearoff=0)

###メニューバー：ラベル
		menu_bar.add_cascade(label="ファイル(F)", menu=menu_file)
		menu_bar.add_cascade(label='設定(E)', menu=menu_edit)
		menu_bar.add_cascade(label='検索(E)', menu=menu_search)
		menu_bar.add_cascade(label='ヘルプ(H)', menu=menu_help)

###メニューバー：内容
		menu_file.add_command(label="新規作成(N)")
		menu_file.add_command(label="開く(O)")
		menu_file.add_command(label="保存(S)")
#		menu_file.add_command(label="閉じる(W)")
		menu_file.add_command(label="終了(Q)",command=self.exit)

		menu_edit.add_command(label="ReadSC channel1",command=conf_ReadSC_Channel1)
		menu_edit.add_command(label="ReadSC channel2",command=conf_ReadSC_Channel2)
		menu_edit.add_command(label="PreAMP(HG)",command=conf_PreAMP1)
		menu_edit.add_command(label="PreAMP(LG)",command=conf_PreAMP2)
		menu_edit.add_command(label="時定数(SSh)",command=conf_time_ssh)
		menu_search.add_command(label="検索(F)")
		menu_help.add_command(label="このアプリケーションについて",command=konoapricationnituite)



##ショートカットキー
		self.master.bind('<Control-KeyPress-q>', self.exit)
		self.master.bind('<Alt-KeyPress-h>', self.help)


##オブジェクトの表示＋配置
		self.textbox.grid(row=0, column=0, columnspan=10)
#		self.label.grid(row=1, column=0, columnspan=10)
#		self.l_par1.grid(row=2, column=0, columnspan=5)
#	self.l_par4.grid(row=2, column=3, columnspan=5)
#		self.l_par2.grid(row=3, column=0, columnspan=5)
#		self.l_par5.grid(row=3, column=3, columnspan=5)
#		self.l_par3.grid(row=4, column=0, columnspan=5)
#		self.l_par6.grid(row=4, column=3, columnspan=5)
		self.bstart.grid(row=5, column=0, columnspan=2)
		self.bstop.grid(row=5, column=2, columnspan=2)
		self.bquit.grid(row=5, column=8, columnspan=2)





##help
	def help(self, event=None):
		f = open('help.txt')
		data1 = f.read()  # ファイル終端まで全て読んだデータを返す
		f.close()
		print data1
		self.textbox.insert(END,data1)
		today_stamp()

##Quit
	def exit(self, event=None):
		self.textbox.insert(END,"EXIT")
		today_stamp()
		self.master.destroy()

##Save Text Log
	def save_log(self, event=None):
		self.textbox.get()
		f = open("./tmp.lg","w")
				

##main
	def __init__(self, master=None):
		Frame.__init__(self, master)
		self.pack()
		self.init()




#oooooooo0000000000000000ooooooooooooo0000000000ooooooooo00000000000oooooooooo
############################
#sub widow: ReadSC Channel1
############################
#
#ここではAnalog Output信号のMPPC Channel番号を設定する.
#設定 -> ReadSCChannel を選択 -> New Window
#そこで、ラジオボタンでchを設定してconfigボタンを押す
#その後、./daqのコマンド2でAnalog Outputのチャンネルが変更される。
#
#oooooooo0000000000000000ooooooooooooo0000000000ooooooooo00000000000oooooooooo
def conf_ReadSC_Channel1():
	global sub_win
	global	action
	if sub_win is None or not sub_win.winfo_exists():
		sub_win = Toplevel()
		sub_win.title('ReadSC channel1 configuration')
		action = IntVar()	
		f = open("./setup/ReadSC_Channel1.txt","r")
		for i in range(7):
			f.readline()
		for i in range(3):
			f.read(2)
		for i in range(32):
			a = int(f.read(2))
			if a==1:
				action.set(i)
		f.close()
		Message(sub_win, aspect = 1000,text = "ReadSC channel1 configuration").pack()
		for i in range(16):
			Radiobutton(sub_win,text = str(i) + "ch", variable = action, value = i, command=state).pack(side="left")
		bconf = Button(sub_win,text='config',command=write_ReadSC_Channel1)
		bconf.pack()
def state():
	print action.get()
def write_ReadSC_Channel1():
	#f = open("write.txt","w")
	f = open("./setup/ReadSC_Channel1.txt","w")
	f.write("#Resister definition Read SC read channel selection\n")
	f.write("StartDefinition\n")
	f.write("BitNum  ArrayNum  BitOrder  A0   A1   A2   A3   A4   A5   A6   A7   A8   A9   A10  A11  A12  A13  A14  A15  A16  A17  A18  A19  A20  A21  A22  A23  A24  A25  A26  A27  A28  A29  A30  A31\n")
	f.write("EndDefinition\n")
	f.write("#BitNum is # of bit in one array\n")
	f.write("#ArrayNum is # of ch ; ArrayNum is 10, Max is A9\n")
	f.write("#BitOrder 0 = LSB to MSB; 1 = MSB to LSB;\n")
	f.write("1 32 0")
	for i in range(32):
		if i==action.get():
				f.write(" 1")
				#print i
		else:
				f.write(" 0")
	f.close()




############################
#sub widow: ReadSC Channel2
############################
def conf_ReadSC_Channel2():
	global sub_win2
	global	action2
	if sub_win2 is None or not sub_win2.winfo_exists():
		sub_win2 = Toplevel()
		sub_win2.title('ReadSC channel2 configuration')
		action2 = IntVar()	
		f = open("./setup/ReadSC_Channel2.txt","r")
		for i in range(7):
			f.readline()
		for i in range(3):
			f.read(2)
		for i in range(32):
			a = int(f.read(2))
			if a==1:
				action2.set(i)
		f.close()
		Message(sub_win2, aspect = 1000,text = "ReadSC channel2 configuration").pack()
		for i in range(16):
			Radiobutton(sub_win2,text = str(i+16) + "ch", variable = action2, value = i, command=state2).pack(side="left")
		bconf = Button(sub_win2,text='config',command=write_ReadSC_Channel2)
		bconf.pack()
def state2():
	print action2.get()+16
def write_ReadSC_Channel2():
	#f = open("write.txt","w")
	f = open("./setup/ReadSC_Channel2.txt","w")
	f.write("#Resister definition Read SC read channel selection\n")
	f.write("StartDefinition\n")
	f.write("BitNum  ArrayNum  BitOrder  A0   A1   A2   A3   A4   A5   A6   A7   A8   A9   A10  A11  A12  A13  A14  A15  A16  A17  A18  A19  A20  A21  A22  A23  A24  A25  A26  A27  A28  A29  A30  A31\n")
	f.write("EndDefinition\n")
	f.write("#BitNum is # of bit in one array\n")
	f.write("#ArrayNum is # of ch ; ArrayNum is 10, Max is A9\n")
	f.write("#BitOrder 0 = LSB to MSB; 1 = MSB to LSB;\n")
	f.write("1 32 0")
	for i in range(32):
		if i==action2.get():
				f.write(" 1")
		else:
				f.write(" 0")
	f.close()



#oooooooo0000000000000000ooooooooooooo0000000000ooooooooo00000000000oooooooooo
##################
#sub widow: PreAMP1 HGPAFback1
##################
#
#ここではPreAmpのGainを設定する.
#設定 -> PreAmp(HG) を選択 -> New Window
#そこで、ラジオボタンでchを設定してconfigボタンを押す
#その後、./daqのコマンド1でAnalog Outputのチャンネルが変更される。
#
#oooooooo0000000000000000ooooooooooooo0000000000ooooooooo00000000000oooooooooo
def conf_PreAMP1():
	global sub_win_PreAMP1
	global	action_PreAMP1
	if sub_win_PreAMP1 is None or not sub_win_PreAMP1.winfo_exists():
		sub_win_PreAMP1 = Toplevel()
		sub_win_PreAMP1.title('HGPAFback1 PreAMP configuration')
		action_PreAMP1 = IntVar()	
		f = open("./setup/HGPAFback1.txt","r")
		for i in range(8):
			f.readline()
		for i in range(3):
			f.read(2)
		a = int(f.read(1))
		action_PreAMP1.set(a)
		f.close()
		Message(sub_win_PreAMP1, aspect = 1000,text = "PreAMP1 configuration").pack()
		gain = ["150","75","50","37.5","30","15"]
		b=0
		for i in [8,4,12,2,10,6]:
			Radiobutton(sub_win_PreAMP1,text = gain[b:b+1], variable = action_PreAMP1, value = i, command=state_PreAMP1).pack()
			b+=1
		bconf = Button(sub_win_PreAMP1,text='config',command=write_PreAMP1)
		bconf.pack()

def state_PreAMP1():
	print action_PreAMP1.get()

def write_PreAMP1():
	#f = open("write.txt","w")
	f = open("./setup/HGPAFback1.txt","w")
	f.write("#Resister definition HGPAFback\n")
	f.write("StartDefinition\n")
	f.write("BitNum  ArrayNum  BitOrder  A0   A1   A2   A3   A4   A5   A6   A7   A8   A9   A10  A11  A12  A13  A14  A15  A16  A17  A18  A19  A20  A21  A22  A23  A24  A25  A26  A27  A28  A29  A30  A31\n")
	f.write("EndDefinition\n")
	f.write("#BitNum is # of bit in one array\n")
	f.write("#ArrayNum is # of ch ; ArrayNum is 10, Max is A9\n")
	f.write("#BitOrder 0 = LSB to MSB; 1 = MSB to LSB;\n")
	f.write("#No C = 0; 100 fF = 8; 200 fF = 4; 300 fF = 12; 400 fF = 2; 500 fF = 10; 600 fF = 6; 700 fF = 14; 800 fF = 1; 900 fF = 9; 1.0 pF = 5; 1.1 pF = 13; 1.2 pF = 3; 1.3 pF = 11; 1.4 pF = 7; 1.5 pF = 15;\n")
	f.write("4 1 0 ")
	f.write(str(action_PreAMP1.get()))
	for i in range(31):
				f.write(" 1")
	f.close()

	f = open("./setup/HGPAFback2.txt","w")
	f.write("#Resister definition HGPAFback\n")
	f.write("StartDefinition\n")
	f.write("BitNum  ArrayNum  BitOrder  A0   A1   A2   A3   A4   A5   A6   A7   A8   A9   A10  A11  A12  A13  A14  A15  A16  A17  A18  A19  A20  A21  A22  A23  A24  A25  A26  A27  A28  A29  A30  A31\n")
	f.write("EndDefinition\n")
	f.write("#BitNum is # of bit in one array\n")
	f.write("#ArrayNum is # of ch ; ArrayNum is 10, Max is A9\n")
	f.write("#BitOrder 0 = LSB to MSB; 1 = MSB to LSB;\n")
	f.write("#No C = 0; 100 fF = 8; 200 fF = 4; 300 fF = 12; 400 fF = 2; 500 fF = 10; 600 fF = 6; 700 fF = 14; 800 fF = 1; 900 fF = 9; 1.0 pF = 5; 1.1 pF = 13; 1.2 pF = 3; 1.3 pF = 11; 1.4 pF = 7; 1.5 pF = 15;\n")
	f.write("4 1 0 ")
	f.write(str(action_PreAMP1.get()))
	for i in range(31):
				f.write(" 1")
	f.close()


##################
#   sub widow
#PreAMP2 LGPAFback
##################
def conf_PreAMP2():
	global sub_win_PreAMP2
	global	action_PreAMP2
	if sub_win_PreAMP2 is None or not sub_win_PreAMP2.winfo_exists():
		sub_win_PreAMP2 = Toplevel()
		sub_win_PreAMP2.title('LGPAFback PreAMP configuration')

		action_PreAMP2 = IntVar()	
		f = open("./setup/LGPAFback1.txt","r")
		for i in range(8):
			f.readline()
		for i in range(3):
			f.read(2)
		a = int(f.read(1))
		action_PreAMP2.set(a)

		#for i in range(31):
			#print(f.read(2))
		f.close()

		Message(sub_win_PreAMP2, aspect = 1000,text = "PreAMP configuration").pack()
		gain = ["15","7.5","5.0","3.75","3.0","1.5"]
		#for i in [8,4,12,2,10,6,14,1,9]:
		b=0
		for i in [8,4,12,2,10,6]:
		#for i in range(6):
			Radiobutton(sub_win_PreAMP2,text = gain[b:b+1], variable = action_PreAMP2, value = i, command=state_PreAMP2).pack()
			b+=1
		bconf = Button(sub_win_PreAMP2,text='config',command=write_PreAMP2)
		bconf.pack()

def state_PreAMP2():
	print action_PreAMP2.get()

def write_PreAMP2():
	#f = open("write.txt","w")
	f = open("./setup/LGPAFback1.txt","w")
	f.write("#Resister definition HGPAFback\n")
	f.write("StartDefinition\n")
	f.write("BitNum  ArrayNum  BitOrder  A0   A1   A2   A3   A4   A5   A6   A7   A8   A9   A10  A11  A12  A13  A14  A15  A16  A17  A18  A19  A20  A21  A22  A23  A24  A25  A26  A27  A28  A29  A30  A31\n")
	f.write("EndDefinition\n")
	f.write("#BitNum is # of bit in one array\n")
	f.write("#ArrayNum is # of ch ; ArrayNum is 10, Max is A9\n")
	f.write("#BitOrder 0 = LSB to MSB; 1 = MSB to LSB;\n")
	f.write("#No C = 0; 100 fF = 8; 200 fF = 4; 300 fF = 12; 400 fF = 2; 500 fF = 10; 600 fF = 6; 700 fF = 14; 800 fF = 1; 900 fF = 9; 1.0 pF = 5; 1.1 pF = 13; 1.2 pF = 3; 1.3 pF = 11; 1.4 pF = 7; 1.5 pF = 15;\n")
	f.write("4 1 0 ")
	f.write(str(action_PreAMP2.get()))
	for i in range(31):
				f.write(" 1")
	f.close()
	f = open("./setup/LGPAFback2.txt","w")
	f.write("\#Resister definition HGPAFback\n")
	f.write("StartDefinition\n")
	f.write("BitNum  ArrayNum  BitOrder  A0   A1   A2   A3   A4   A5   A6   A7   A8   A9   A10  A11  A12  A13  A14  A15  A16  A17  A18  A19  A20  A21  A22  A23  A24  A25  A26  A27  A28  A29  A30  A31\n")
	f.write("EndDefinition\n")
	f.write("#BitNum is # of bit in one array\n")
	f.write("#ArrayNum is # of ch ; ArrayNum is 10, Max is A9\n")
	f.write("#BitOrder 0 = LSB to MSB; 1 = MSB to LSB;\n")
	f.write("#No C = 0; 100 fF = 8; 200 fF = 4; 300 fF = 12; 400 fF = 2; 500 fF = 10; 600 fF = 6; 700 fF = 14; 800 fF = 1; 900 fF = 9; 1.0 pF = 5; 1.1 pF = 13; 1.2 pF = 3; 1.3 pF = 11; 1.4 pF = 7; 1.5 pF = 15;\n")
	f.write("4 1 0 ")
	f.write(str(action_PreAMP2.get()))
	for i in range(31):
				f.write(" 1")
	f.close()


#oooooooo0000000000000000ooooooooooooo0000000000ooooooooo00000000000oooooooooo
##################
#sub widow: TimeCHGSSh1
##################
#
#ここではSlowShaperの時定数を設定する.
#設定 -> TimeCoeff. を選択 -> New Window
#そこで、ラジオボタンでchを設定してconfigボタンを押す
#その後、./daqのコマンド1でチャンネルが変更される。
#
#oooooooo0000000000000000ooooooooooooo0000000000ooooooooo00000000000oooooooooo
def conf_time_ssh():
	global sub_win_time_ssh
	global	action_time_ssh
	if sub_win_time_ssh is None or not sub_win_time_ssh.winfo_exists():
		sub_win_time_ssh = Toplevel()
		sub_win_time_ssh.title('SlowShaper time-coefficient configuration')
		action_time_ssh = IntVar()	
		f = open("./setup/TimeCHGSSh1.txt","r")
		for i in range(8):
			f.readline()
		for i in range(3):
			f.read(2)
		a = int(f.read(1))
		action_time_ssh.set(a)
		f.close()
		Message(sub_win_time_ssh, aspect = 1000,text = "PreAMP1 configuration").pack()
		gain = ["25ns","50ns","75ns","100ns","125ns","150ns","175ns"]
		b=0
		for i in [3,5,1,6,2,4,0]:
			Radiobutton(sub_win_time_ssh,text = gain[b:b+1], variable = action_time_ssh, value = i, command=state_time_ssh).pack()
			b+=1
		bconf = Button(sub_win_time_ssh,text='config',command=write_time_ssh)
		bconf.pack()

def state_time_ssh():
	print action_time_ssh.get()

def write_time_ssh():
	#f = open("write.txt","w")
	f = open("./setup/TimeCHGSSh1.txt","w")
	f.write("#Resister definition TimeCHGSSh\n")
	f.write("StartDefinition\n")
	f.write("BitNum  ArrayNum  BitOrder  A0   A1   A2   A3   A4   A5   A6   A7   A8   A9   A10  A11  A12  A13  A14  A15  A16  A17  A18  A19  A20  A21  A22  A23  A24  A25  A26  A27  A28  A29  A30  A31\n")
	f.write("EndDefinition\n")
	f.write("#BitNum is # of bit in one array\n")
	f.write("#ArrayNum is # of ch ; ArrayNum is 10, Max is A9\n")
	f.write("#BitOrder 0 = LSB to MSB; 1 = MSB to LSB;\n")
	f.write("#25ns = 3; 50ns = 5; 75ns = 1; 100ns = 6; 125ns = 2; 150ns = 4; 175ns = 0;\n")
	f.write("3 1 1 ")
	f.write(str(action_time_ssh.get()))
	for i in range(31):
				f.write(" 1")
	f.close()
	f = open("./setup/TimeCHGSSh2.txt","w")
	f.write("#Resister definition TimeCHGSSh\n")
	f.write("StartDefinition\n")
	f.write("BitNum  ArrayNum  BitOrder  A0   A1   A2   A3   A4   A5   A6   A7   A8   A9   A10  A11  A12  A13  A14  A15  A16  A17  A18  A19  A20  A21  A22  A23  A24  A25  A26  A27  A28  A29  A30  A31\n")
	f.write("EndDefinition\n")
	f.write("#BitNum is # of bit in one array\n")
	f.write("#ArrayNum is # of ch ; ArrayNum is 10, Max is A9\n")
	f.write("#BitOrder 0 = LSB to MSB; 1 = MSB to LSB;\n")
	f.write("#25ns = 3; 50ns = 5; 75ns = 1; 100ns = 6; 125ns = 2; 150ns = 4; 175ns = 0;\n")
	f.write("3 1 1 ")
	f.write(str(action_time_ssh.get()))
	for i in range(31):
				f.write(" 1")
	f.close()
	f = open("./setup/TimeCLGSSh1.txt","w")
	f.write("#Resister definition TimeCHGSSh\n")
	f.write("StartDefinition\n")
	f.write("BitNum  ArrayNum  BitOrder  A0   A1   A2   A3   A4   A5   A6   A7   A8   A9   A10  A11  A12  A13  A14  A15  A16  A17  A18  A19  A20  A21  A22  A23  A24  A25  A26  A27  A28  A29  A30  A31\n")
	f.write("EndDefinition\n")
	f.write("#BitNum is # of bit in one array\n")
	f.write("#ArrayNum is # of ch ; ArrayNum is 10, Max is A9\n")
	f.write("#BitOrder 0 = LSB to MSB; 1 = MSB to LSB;\n")
	f.write("#25ns = 3; 50ns = 5; 75ns = 1; 100ns = 6; 125ns = 2; 150ns = 4; 175ns = 0;\n")
	f.write("3 1 1 ")
	f.write(str(action_time_ssh.get()))
	for i in range(31):
				f.write(" 1")
	f.close()
	f = open("./setup/TimeCLGSSh2.txt","w")
	f.write("#Resister definition TimeCHGSSh\n")
	f.write("StartDefinition\n")
	f.write("BitNum  ArrayNum  BitOrder  A0   A1   A2   A3   A4   A5   A6   A7   A8   A9   A10  A11  A12  A13  A14  A15  A16  A17  A18  A19  A20  A21  A22  A23  A24  A25  A26  A27  A28  A29  A30  A31\n")
	f.write("EndDefinition\n")
	f.write("#BitNum is # of bit in one array\n")
	f.write("#ArrayNum is # of ch ; ArrayNum is 10, Max is A9\n")
	f.write("#BitOrder 0 = LSB to MSB; 1 = MSB to LSB;\n")
	f.write("#25ns = 3; 50ns = 5; 75ns = 1; 100ns = 6; 125ns = 2; 150ns = 4; 175ns = 0;\n")
	f.write("3 1 1 ")
	f.write(str(action_time_ssh.get()))
	for i in range(31):
				f.write(" 1")
	f.close()



#oooooooo0000000000000000ooooooooooooo0000000000ooooooooo00000000000oooooooooo
##################
#このアプリケーションについて
##################
def konoapricationnituite():
	global sub_win_ver
	if sub_win_ver is None or not sub_win_ver.winfo_exists():
		sub_win_ver = Toplevel()
		sub_win_ver.title('このアプリケーションについて')
		Message(sub_win_ver, aspect = 1000,text = u'このアプリケーションについて').pack()
		label = Label(sub_win_ver,text='DAQ system EASIROC & CAMAC',fg='blue').pack()
		label = Label(sub_win_ver,text='バージョン0.0.2',fg='blue').pack()
		label = Label(sub_win_ver,text='',fg='blue').pack()
		label = Label(sub_win_ver,text='made by hiroshi',fg='blue').pack()
		bext = Button(sub_win_ver,text='exit',command=sub_win_ver.destroy).pack()


##################
#   sub widow
##################
def message_window():
	global sub_win
	if sub_win is None or not sub_win.winfo_exists():
		sub_win = Toplevel()
		sub_win.title('About')
		#opts1 = BooleanVar()
		#opts1.set(True)
		#opts2 = BooleanVar()
		#opts2.set(False)
		#opts3 = BooleanVar()
		#opts3.set(True)
		#action = IntVar()
		#action.set(1)
		Message(sub_win, aspect = 200,text = u'message のサンプルプログラムです').pack()
		#Checkbutton(sub_win,text = 'option 2', variable = opts2).pack(side="left")
		#Checkbutton(sub_win,text = 'option 3', variable = opts3).pack(side="left")
		num = 0
		while num < 10:
			opts[num] = BooleanVar()
			#opts[num].set(True)
			Checkbutton(sub_win,text = num+' ch', variable = opts[num]).pack(side="left")
			num +=1


#oooooooo0000000000000000ooooooooooooo0000000000ooooooooo00000000000oooooooooo
############
#   main
############
if __name__ == "__main__":
	sub_win = None
	sub_win2 = None
	sub_win_PreAMP1 = None
	sub_win_PreAMP2 = None
	sub_win_ver = None
	sub_win_time_ssh = None

	app = App()
	init_sys()
	app.mainloop()

#	if 

	print 'END OF MAIN'
#oooooooo0000000000000000ooooooooooooo0000000000ooooooooo00000000000oooooooooo
