//#include "camac.cxx"

TGCheckButton*check_easiroc		= new TGCheckButton();
TGCheckButton*check_camac		= new TGCheckButton();
TGTextEntry*entry					= new TGTextEntry();
TGTextEntry*entry_RunNo			= new TGTextEntry();
TGTextEntry*entry_comment		= new TGTextEntry();
TGTextEntry*entry_EvNo			= new TGTextEntry();
TGTextEntry*entry_ADC   = new TGTextEntry();
TGTextEntry*entry_ADCch = new TGTextEntry();
TGTextEntry*entry_TDC   = new TGTextEntry();
TGTextEntry*entry_TDCch = new TGTextEntry();
#include <time.h>

//************************************************
//                DAQ START
//************************************************
void DAQSTART(){

int sw_easiroc=0,sw_camac=0;
char name[100],cmd[100];
int RunNo = atoi(entry_RunNo->GetText());


sw_easiroc = check_easiroc->GetState();
sw_camac = check_camac->GetState();

ofstream ofs("./setup/EventNum.txt");
	ofs<<entry_EvNo->GetText();

//*****************************
//CAMAC + EASIROC DAQ START
if(sw_easiroc==1 && sw_camac==1){
	system("sh ./include/DAQSTART.sh 1");
	cout <<"daq1\n";
}

//********************
//EASIROC DAQ START
if(sw_easiroc==1 && sw_camac==0){
	system("sh ./include/DAQSTART.sh 2");
	cout <<"daq2\n";
}


//********************
//CAMAC DAQ START
if(sw_easiroc==0 && sw_camac==1){
sprintf(name,"sh ./include/DAQSTART.sh 3 %sdata/run%05d.cmd",entry->GetText(),(int)atoi(entry_RunNo->GetText()));
system(name);

	//********************
	//adding run nomber2
	sprintf(name,"%srunnum.txt",entry->GetText());
	ofstream ofs(name);
	ofs<<RunNo+1;
	ofs.close();

	//********************
	// writing comments
	time_t now = time(NULL);
	struct tm *pnow = localtime(&now);
	sprintf(name,"%scomment.txt",entry->GetText());
	ofstream ofs(name,ios::app);
	sprintf(name,"%04d/%02d/%02d/%02d:%02d:%02d",pnow->tm_year+1900,
			pnow->tm_mon+1,pnow->tm_mday+1,pnow->tm_hour,
			pnow->tm_min,pnow->tm_sec);
	ofs<<name<<" "
		<<RunNo<<" "
		<<entry_comment->GetText()<<endl;
	ofs.close();
}


else cout<<"no check\n";
}




//************************************************
//                DAQ STOP
//************************************************
void DAQSTOP(){
int sw_easiroc=0,sw_camac=0;
char name[100],cmd[100];
sw_easiroc = check_easiroc->GetState();
sw_camac = check_camac->GetState();

if(sw_easiroc==1 && sw_camac==0){
system("killall -9 easiroc");
}


if(sw_easiroc==1 && sw_camac==1){
system("killall -9 easiroc^camac");
}


if(sw_easiroc==0 && sw_camac==1){
system("killall -9 camac");
}


if(sw_easiroc==0 && sw_camac==0){
	cout<<"no check\n";}

sprintf(name,"%srunnum.txt",entry->GetText());
	ifstream ifs(name);
	ifs>>name;
	ifs.close();
	entry_RunNo->SetText(name);

}
