//*****************
//  main func.
//*****************
void hist(){
gROOT->LoadMacro("./include/ProcEvent.C");
char name[100],cmd[100];
//double x;
ifstream ifs("./setup/MonitorFile.txt");
	ifs>>cmd;
	ifs.close();
ifstream ifs("./setup/WorkDIR.txt");
	ifs>>name;
	ifs.close();
sprintf(name,"%sdata/%s",name,cmd);
//cout<<"cmd "<<name<<" "<<StrString(name,"cmd")<<endl;//camac data
//cout<<"esd "<<name<<" "<<StrString(name,"esd")<<endl;//eaasiroc data
//cout<<"ecd "<<name<<" "<<StrString(name,"ecd")<<endl;//easiroc + camac data
if(StrString(name,"cmd")==0 &&
	StrString(name,"esd")==0 &&
	StrString(name,"ecd")==0){
		cout<<"no file\n";
		return;}


if(StrString(name,"cmd")!=0)// CAMAC DATA offline monitor
	camac_offline_monitor(name);

if(StrString(name,"esd")!=0)// EASIROC DATA offline monitor
	easiroc_offline_monitor(name);

if(StrString(name,"ecd")!=0)// EASIROC + CAMAC DATA offline monitor
	easiroc_camac_offline_monitor(name);
}


//****************************
//   文字列部分一致検索
//****************************
int StrString(const char *s1, const char *s2){
int n;
	n = strlen(s2);                            /* 文字列s2の長さを求める */
	while (1) {
	s1 = strchr(s1, s2[0]);                /* s2の先頭の１文字を探す */
	if(s1 == NULL)                        /* 見つからなければ */
	return 0;									/* NULLを返す */
	if(strncmp(s1, s2, n) == 0)            /* 見つかったらn文字比較 */
	return 1;//(char *)s1;                 /* 一致したらポインタを返す */
	s1++;    /* ポインタを進めて */         /* s1はconstを付けて宣言 */
}}


//****************************
//CAMAC Offline Monitor
//****************************
camac_offline_monitor(char*name){
gStyle->SetOptStat(1001110);
ifstream ifs(name);//input file name
double x;
adc[16]=new TH1S();
for(int i=0;i<16;i++){
	sprintf(name,"adc%d",i);
	adc[i]=new TH1S(name,name,4096,0,4096);}
tdc[16] =new TH1S();
for(int i=0;i<16;i++){
	sprintf(name,"tdc%d",i);
	tdc[i]=new TH1S(name,name,4096,0,4096);}

int j=0;
while(!ifs.eof()){
	j++;
	for(int i=0;i<16;i++){
		ifs>>x;
		adc[i]->Fill(x);}
	for(int i=0;i<16;i++){
		ifs>>x;
		tdc[i]->Fill(x);}
	if(j%100==0)cout<<"."<<flush;}
ifs.close();
	
c1=new TCanvas("c1");
c1->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",
                        0, 0, "ProcEvent(Int_t,Int_t,Int_t,TObject*)");
c1->Divide(4,4);
for(int i=0;i<16;i++){
	c1->cd(i+1);
	adc[i]->Draw();}

c2=new TCanvas("c2");
c2->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",
                        0, 0, "ProcEvent(Int_t,Int_t,Int_t,TObject*)");
c2->Divide(4,2);
for(int i=0;i<8;i++){
	c2->cd(i+1);
	tdc[i]->Draw();}
}

//************************************
//EASIROC Offline Monitor
//************************************
easiroc_offline_monitor(char*name){
gStyle->SetOptStat(1001110);
int n;

ifstream ifs(name, std::ios::binary);//ファイルオープン
if(!ifs.is_open()){//もし開かなかったら終了
	cout << "\nno file" << endl;
	return;}

adc[64]=new TH1F();//EASIROC MPPC
	for(int i=0;i<64;i++){
	sprintf(name,"adc%d",i);
	adc[i]=new TH1F(name,name,4096,0,4095);}
	chhist = new TH2F("chhist","",64,0-0.5,64-0.5,1500,500,2000);

while(!ifs.eof()){
	int data;
	ifs.read((char*)&data, sizeof(int));
	if((unsigned int)data == 0xffffea0c){
	ifs.read((char*)&data, sizeof(int));
	int NofWord = data & 0xffff;
	ifs.read((char*)&data, sizeof(int));
	for(int i = 0; i<NofWord; ++i){
		ifs.read((char*)&data, sizeof(int));
		if(0x81 == ((data >> 24) & 0xff)){
			int channel = (data >> 16) & 0xff;
			int val = data & 0xfff;
			adc[channel]->Fill(val);
			chhist->Fill(i-1,val);}
		if(0x60 == ((data >> 24) & 0xff)){
			int channel = (data >> 16) & 0xff;
			int val = data & 0xfff;
			adc[channel+32]->Fill(val);
			chhist->Fill(i-1,val);}}
        n++;}
if(n%100==0)cout<<"."<<flush;
}
c1=new TCanvas("c1");
c1->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",0,0,"ProcEvent(Int_t,Int_t,Int_t,TObject*)");
c1->Divide(8,8);
for(int i=0;i<64;i++){
	c1->cd(i+1);
	adc[i]->Draw();}

c2=new TCanvas("c2");
chhist->Draw("colz");}



//************************************
//EASIROC + CAMAC Offline Monitor
//************************************
easiroc_camac_offline_monitor(char*name){
gStyle->SetOptStat(1001110);
int n;

ifstream ifs(name, std::ios::binary);//ファイルオープン
if(!ifs.is_open()){//もし開かなかったら終了
	cout << "\nno file" << endl;
	return;}

adc_c[16]=new TH1F();//CAMAC ADC
	for(int i=0;i<16;i++){
	sprintf(name,"adc_c%d",i);
	adc_c[i]=new TH1F(name,name,4096,0,4096);}
tdc_c[16]=new TH1F();//CAMAC TDC
	for(int i=0;i<16;i++){
	sprintf(name,"tdc_c%d",i);
	tdc_c[i]=new TH1F(name,name,4096,0,4095);}
adc[64]=new TH1F();//EASIROC MPPC
	for(int i=0;i<64;i++){
	sprintf(name,"adc%d",i);
	adc[i]=new TH1F(name,name,4096,0,4095);}
	chhist = new TH2F("chhist","",64,0-0.5,64-0.5,1500,500,2000);

while(!ifs.eof()){
	int data;
	ifs.read((char*)&data, sizeof(int));
	if((unsigned int)data == 0xffffea0c){
//	for(int ch = 0; ch<32; ++ch){
//		index[ch] = 0;
//		index_n[ch] = 0;
//		adc[ch] = -1;}
	ifs.read((char*)&data, sizeof(int));
	int NofWord = data & 0xffff;
	ifs.read((char*)&data, sizeof(int));
	
//cout<<NofWord<<endl;
//return;

	for(int i = 0; i<NofWord; ++i){
		ifs.read((char*)&data, sizeof(int));
		if(0x81 == ((data >> 24) & 0xff)){
			int channel = (data >> 16) & 0xff;
			int val = data & 0xfff;
			adc[channel]->Fill(val);
			chhist->Fill(i-1,val);}
		if(0x60 == ((data >> 24) & 0xff)){
			int channel = (data >> 16) & 0xff;
			int val = data & 0xfff;
			adc[channel+32]->Fill(val);
			chhist->Fill(i-1,val);}
        }

  for(int i = 0; i<16; ++i){
  ifs.read((char*)&data, sizeof(int));
        if(0x71 == ((data >> 24) & 0xff)){
          int channel = (data >> 16) & 0xff;
          int val = data & 0xfff;
                adc_c[channel]->Fill(val);
                //cout << adc_c[channel] << " ";
                }}
        //cout << endl;

  for(int i = 0; i<16; ++i){
  ifs.read((char*)&data, sizeof(int));
        if(0x62 == ((data >> 24) & 0xff)){
          int channel = (data >> 16) & 0xff;
          int val = data & 0xfff;
                tdc_c[channel]->Fill(val);
                }}
        n++;

        //if(n%=10)cout<<".";
//        tree->Fill();
        }
if(n%100==0)cout<<"."<<flush;
}

c1=new TCanvas("c1");
c1->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",0,0,"ProcEvent(Int_t,Int_t,Int_t,TObject*)");
c1->Divide(4,4);
for(int i=0;i<16;i++){
	c1->cd(i+1);
	adc_c[i]->Draw();}

c2=new TCanvas("c2");
c2->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",0,0,"ProcEvent(Int_t,Int_t,Int_t,TObject*)");
c2->Divide(4,4);
for(int i=0;i<16;i++){
	c2->cd(i+1);
	tdc_c[i]->Draw();}

c3=new TCanvas("c3");
c3->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",0,0,"ProcEvent(Int_t,Int_t,Int_t,TObject*)");
c3->Divide(8,8);
for(int i=0;i<64;i++){
	c3->cd(i+1);
	adc[i]->Draw();}

c4=new TCanvas("c4");
chhist->Draw("colz");
}
