/*********************************
DAQ SYSTEM
	get_nd ver14.1
readout
 1CH PMT ADC
made 2014.03.01 by H.ITO
---------
コンパイル
---------
 $cd DAQ
 $c++ -o get_nd get_nd14.1.cpp
---------
実行コマンド
---------
	$./get_nd
**********************************/
#include<stdio.h>
#include<stdlib.h>
#include<iostream>
#include<fstream>
#include<sys/stat.h>
#include "/usr/local/camlib/camlib.c"
#include "/usr/local/camlib/camlib.h"
int main(void){
	using namespace std;//std::省略用

	int a=0;
	char name[100],tmp[100],cmd[100];
	const int EVE_NUM = 1000000;
	char dir[100]="data000";
	int file;//file_number

	cout<<"message:転送先は../Rawdata2/\n";
	cout<<"message:ファイル番号を入力してください(int型)>>";
	cin>>file;

	const int MOD_NUM1 = 4;//ADC
	const int MOD_NUM2 = 2;//TDC

	const int SUB_NUM1 = 0;//ADCport01
	int data1,q1,x1;

	const int SUB_NUM2 = 1;//ADCport02
	int data2,q2,x2;

/*	const int SUB_NUM3 = 2;//ADCport03
	int data3,q3,x3;

	const int SUB_NUM4 = 3;//ADCport04
	int data4,q4,x4;

	const int SUB_NUM5 = 0;//TDCport01
	int data5,q5,x5;

	const int SUB_NUM6 = 1;//TDCport02
	int data6,q6,x6;

	const int SUB_NUM7 = 2;//TDCport03
	int data7,q7,x7;

	const int SUB_NUM8 = 3;//TDCport04
	int data8,q8,x8;
	//const int SUB_NUM2 = 15;//port02
	//int data2,q2,x2;
*/
	int tdc_out=0;

	COPEN();
	CGENZ();

	sprintf(name,"../Rawdata2/data%03d.dat",file);
	struct stat st1;
	int ret1 = stat(name,&st1);
	if(0 != ret1){
		//sprintf(cmd,"mkdir ./Rawdata/%sf%05d.dat",dir,file);
		//system(cmd);
		//cout<<"cmd::"<<cmd<<endl;
		}
	else{
		cout<<"message::"<<"データを上書きしますか？\nYes[1]/No[0]]>>";
		cin >>a;
		while(a!=0&&a!=1){
			cout<<"message::"<<"もう一度入力してください\nYes[1]/No[0]]>>";
			cin>>a;
			}
		if(a==0)exit(1);
		}

	//無限ループ
	int loop_num=0;
	for(int i=0;i<=loop_num;i++){
		//file_name="f_00000.dat"作成
		sprintf(name,"../Rawdata2/data%03d.dat",file);

		//ファイル作成＆書込
		ofstream ofs(name);

		//作成ファイル存在確認
		struct stat st;
		int ret = stat(name, &st);
		if(0 == ret){
			cout << name <<"[succes]" << endl;
			
//内容
int j=0;
while(j<EVE_NUM){
	tdc_out=0;
	CAMAC(NAF(MOD_NUM1,SUB_NUM1,8),&data1,&q1,&x1);//ADC event
	if(q1==1){
		CAMAC(NAF(MOD_NUM1,SUB_NUM1,0),&data1,&q1,&x1);
		CAMAC(NAF(MOD_NUM1,SUB_NUM2,0),&data2,&q2,&x2);
		ofs << data1<<" "<<data2<<endl;
		j++;
		if(j%100 == 0)cout <<"."<<flush;
		CAMAC(NAF(MOD_NUM1,SUB_NUM1,9),&data1,&q1,&x1);
		CAMAC(NAF(MOD_NUM1,SUB_NUM2,9),&data2,&q2,&x2);
		}
	}
	ofs.close();
	cout <<endl;
	}

	else{
		cout << name <<"[failure]" << endl;
		}
}
	return 0;
}
