#include "./include/ChangeOutputFile.cxx"
#include "./include/DAQSTART.cxx"
//#include "./include/UDPSTART.cxx"

TGMainFrame*MainFrame = new TGMainFrame();

TGCheckButton*check_easiroc = new TGCheckButton();
TGCheckButton*check_camac = new TGCheckButton();

TGTextEntry*entry = new TGTextEntry();
TGTextEntry*entry_comment = new TGTextEntry();
TGTextEntry*entry_RunNo = new TGTextEntry();


#include "./include/easiroc_parameter.cxx"
TGComboBox *entry_HGPreAmp = new TGComboBox();
int HGPreAmp_easiroc, LGPreAmp_easiroc, timeSSH_easiroc;

void guitest(){
char name[1000],cmd[1000];

//**********************************
// main frame
//**********************************
MainFrame = new TGMainFrame(gClient->GetRoot(),10,10,kMainFrame | kVerticalFrame);
MainFrame->SetName("MainFrame");
MainFrame->SetLayoutBroken(kTRUE);

//**********************************
// comment
label_comment = new TGLabel(MainFrame,"comment");
	MainFrame->AddFrame(label_comment,
		new TGLayoutHints(kLHintsLeft |	kLHintsTop,2,2,2,2));
	label_comment->MoveResize(8,8,45,16);

TGFont*ufont_comment;
ufont_comment = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
TGGC*uGC_comment;
GCValues_t valcomment;
uGC_comment = gClient->GetGC(&valcomment, kTRUE);

entry_comment = new TGTextEntry(MainFrame, new TGTextBuffer(14),
	-1,uGC_comment->GetGC(),ufont_comment->GetFontStruct(),
	kSunkenFrame | kOwnBackground);
entry_comment->SetText("");
entry_comment->Resize(272,entry_comment->GetDefaultHeight());
entry_comment->MoveResize(56,8,272,20);


//**********************************
// check box
check_easiroc = new TGCheckButton(MainFrame,"EASIROC");
//check_easiroc->SetState(kButtonDown);
check_easiroc->MoveResize(112,32,111,17);

check_camac = new TGCheckButton(MainFrame,"CAMAC");
check_camac->SetState(kButtonDown);
check_camac->MoveResize(112,48,117,17);

//**********************************
// DAQ button
TGTextButton *Button_DAQ = new TGTextButton(MainFrame,"DAQ START",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button_DAQ->MoveResize(10,32,80,20);
Button_DAQ->Connect("Clicked()",0,0,"DAQSTART()");

/*TGTextButton *Button_UDP = new TGTextButton(MainFrame,"UDP START",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button_UDP->MoveResize(10,54,80,20);
Button_UDP->Connect("Clicked()",0,0,"UDP()");*/

TGTextButton *Button_STOP = new TGTextButton(MainFrame,"STOP",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button_STOP->MoveResize(10,54,80,20);
Button_STOP->Connect("Clicked()",0,0,"DAQSTOP()");


TGTextButton *Button_QUIT = new TGTextButton(MainFrame,"QUIT",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button_QUIT->MoveResize(10,76,80,20);
Button_QUIT->Connect("Clicked()",0,0,"CloseWin()");

//**********************************
// run No.
label_comment = new TGLabel(MainFrame,"Run No.");
	MainFrame->AddFrame(label_comment,
		new TGLayoutHints(kLHintsLeft |	kLHintsTop,2,2,2,2));
	label_comment->MoveResize(120,78,45,16);

TGFont*ufont_RunNo;
ufont_RunNo = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
TGGC*uGC_RunNo;
GCValues_t valRunNo;
uGC_RunNo = gClient->GetGC(&valRunNo, kTRUE);

entry_RunNo = new TGTextEntry(MainFrame, new TGTextBuffer(14),
	-1,uGC_RunNo->GetGC(),ufont_RunNo->GetFontStruct(),
	kSunkenFrame | kOwnBackground);
entry_RunNo->SetText("");
entry_RunNo->Resize(272,entry_RunNo->GetDefaultHeight());
entry_RunNo->MoveResize(170,76,40,20);



fLabel1344 = new TGLabel(MainFrame,"fLabel1344");
   fLabel1344->SetTextJustify(36);
   fLabel1344->SetMargins(0,0,0,0);
   fLabel1344->SetWrapLength(-1);
   MainFrame->AddFrame(fLabel1344, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
fLabel1344->MoveResize(8,112,62,16);

fLabel1349 = new TGLabel(MainFrame,"fLabel1349");
fLabel1349->SetTextJustify(36);
fLabel1349->SetMargins(0,0,0,0);
fLabel1349->SetWrapLength(-1);
MainFrame->AddFrame(fLabel1349, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
fLabel1349->MoveResize(8,136,62,24);

TGLabel *fLabel1358 = new TGLabel(MainFrame,"fLabel1358");
   fLabel1358->SetTextJustify(36);
   fLabel1358->SetMargins(0,0,0,0);
   fLabel1358->SetWrapLength(-1);
   MainFrame->AddFrame(fLabel1358, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fLabel1358->MoveResize(8,168,62,24);





//**********************************
// GroupFrame
//**********************************
TGGroupFrame *frame_conf = new TGGroupFrame(MainFrame,"configuration");
frame_conf->SetLayoutBroken(kTRUE);

//**********************************
// output file DIR dispray
label_DIR = new TGLabel(frame_conf,"DIR:");
	label_DIR->SetMargins(0,0,0,0);
	label_DIR->MoveResize(5,20,50,16);

TGFont*ufont_DIR;
ufont_DIR = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
TGGC*uGC_DIR;
GCValues_t val_filename;
uGC_DIR = gClient->GetGC(&val_filename, kTRUE);
entry = new TGTextEntry(frame_conf, new TGTextBuffer(14),
	-1,uGC_DIR->GetGC(),ufont_DIR->GetFontStruct(),
	kSunkenFrame | kOwnBackground);
entry->SetAlignment(kTextLeft);
ifstream ifs("./setup/WorkDIR.txt");
ifs>>name;
ifs.close();
entry->SetText(name);
entry->Resize(272,entry->GetDefaultHeight());
entry->MoveResize(50,16,220,20);

Button = new TGTextButton(frame_conf,"OK",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button->MoveResize(281,20,50,16);
Button->Connect("Clicked()",0,0,"config_fileIO()");


//**********************************
// EASIROC conf.
//**********************************
label_DIR = new TGLabel(frame_conf,"EASIROC PARAMETER:");
	label_DIR->SetMargins(0,0,0,0);
	label_DIR->MoveResize(10,40,125,16);

// High Gain 
label_DIR = new TGLabel(frame_conf,"PreAmp HG");
	label_DIR->SetMargins(0,0,0,0);
	label_DIR->MoveResize(25,60,80,16);

TGComboBox *entry_HGPreAmp = new TGComboBox(frame_conf,-1,kHorizontalFrame | kSunkenFrame | kOwnBackground);
//entry_HGPreAmp->SetName("entry_HGPreAmp");
entry_HGPreAmp->AddEntry("150  ",1);
entry_HGPreAmp->AddEntry(" 75  ",2);
entry_HGPreAmp->AddEntry(" 50  ",3);
entry_HGPreAmp->AddEntry(" 37.5",4);
entry_HGPreAmp->AddEntry(" 30  ",5);
entry_HGPreAmp->AddEntry(" 15  ",6);
entry_HGPreAmp->Resize(256,20);
HGPreAmp_easiroc = GetHGPreAmp_easiroc();//########
entry_HGPreAmp->Select(HGPreAmp_easiroc);
frame_conf->AddFrame(entry_HGPreAmp, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
entry_HGPreAmp->MoveResize(150,60,150,20);

Button_HGPreAmp = new TGTextButton(frame_conf,"OK",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button_HGPreAmp->MoveResize(281,60,50,16);
Button_HGPreAmp->Connect("Clicked()",0,0,"SetHGPreAmp_easiroc()");




   TGLabel *fLabel1392 = new TGLabel(frame_conf,"fLabel1392");
   fLabel1392->SetTextJustify(36);
   fLabel1392->SetMargins(0,0,0,0);
   fLabel1392->SetWrapLength(-1);
   frame_conf->AddFrame(fLabel1392, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fLabel1392->MoveResize(16,96,62,16);
   TGLabel *fLabel1399 = new TGLabel(frame_conf,"fLabel1399");
   fLabel1399->SetTextJustify(36);
   fLabel1399->SetMargins(0,0,0,0);
   fLabel1399->SetWrapLength(-1);
   frame_conf->AddFrame(fLabel1399, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fLabel1399->MoveResize(8,120,62,16);
   TGLabel *fLabel1406 = new TGLabel(frame_conf,"fLabel1406");
   fLabel1406->SetTextJustify(36);
   fLabel1406->SetMargins(0,0,0,0);
   fLabel1406->SetWrapLength(-1);
   frame_conf->AddFrame(fLabel1406, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fLabel1406->MoveResize(16,144,62,16);
   TGLabel *fLabel1413 = new TGLabel(frame_conf,"fLabel1413");
   fLabel1413->SetTextJustify(36);
   fLabel1413->SetMargins(0,0,0,0);
   fLabel1413->SetWrapLength(-1);
   frame_conf->AddFrame(fLabel1413, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fLabel1413->MoveResize(8,168,62,16);

   frame_conf->SetLayoutManager(new TGVerticalLayout(frame_conf));
   frame_conf->Resize(336,200);
   MainFrame->AddFrame(frame_conf, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   frame_conf->MoveResize(336,0,336,200);
   TGNumberEntry *fNumberEntry1068 = new TGNumberEntry(MainFrame, (Double_t) 0,6,-1,(TGNumberFormat::EStyle) 5);
   fNumberEntry1068->SetName("fNumberEntry1068");
   MainFrame->AddFrame(fNumberEntry1068, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fNumberEntry1068->MoveResize(72,112,53,20);


   TGNumberEntry *fNumberEntry1251 = new TGNumberEntry(MainFrame, (Double_t) 0,6,-1,(TGNumberFormat::EStyle) 5);
   fNumberEntry1251->SetName("fNumberEntry1251");
   MainFrame->AddFrame(fNumberEntry1251, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fNumberEntry1251->MoveResize(72,136,53,20);









   MainFrame->SetMWMHints(kMWMDecorAll,
                        kMWMFuncAll,
                        kMWMInputModeless);
   MainFrame->MapSubwindows();

   MainFrame->Resize(MainFrame->GetDefaultSize());
   MainFrame->MapWindow();
   MainFrame->Resize(683,196);
}

void CloseWin(){
cout<<"close\n";
MainFrame->CloseWindow();
}
