TGTextEntry*entry					= new TGTextEntry();
TGNumberEntry*entry_monitor		= new TGNumberEntry();
TGMainFrame*FrameEMonitor 		= new TGMainFrame();
TGTextButton *Button_e1monitor 	= new TGTextButton();
TGTextButton *Button_e2monitor 	= new TGTextButton();
TGNumberEntry*entry_e1monitor	= new TGNumberEntry();
TGNumberEntry*entry_e2monitor	= new TGNumberEntry();

//******************
// ヒストグラム モニタ
void monitor_hist(){
char name[100],cmd[100];
double x;
sprintf(name,"ls %sdata | grep %05d > ./setup/MonitorFile.txt",entry->GetText(),(int)entry_monitor->GetNumber());
system(name);
system("sh ./include/Monitor.sh");
}



//***********************************
// EASIROC Analog output monitor
// configuration
void EASIROCMONITOR(){
	FrameEMonitor = new TGMainFrame(
		gClient->GetRoot(),10,10,kMainFrame | kVerticalFrame);
	FrameEMonitor->SetName("MainFrame");
	FrameEMonitor->SetLayoutBroken(kTRUE);

	//タイトル
	label_comment = new TGLabel(FrameEMonitor,
		"EASIROC ANALOG OUTPUT MONITOR");
	FrameEMonitor->AddFrame(label_comment,
		new TGLayoutHints(kLHintsLeft |	kLHintsTop,2,2,2,2));
	label_comment->MoveResize(50,5,400,16);


	//アナログoutput1　channel設定
	label = new TGLabel(FrameEMonitor,"channel(1):");
	label->SetTextJustify(36);
	label->SetMargins(0,0,0,0);
	label->SetWrapLength(-1);
	FrameEMonitor->AddFrame(label,
		new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
	label->MoveResize(8,30,70,20);

	TGFont*ufont_e1monitor;
	ufont_e1monitor = gClient->GetFont(
		"-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
	TGGC*uGC_e1monitor;
	GCValues_t vale1monitor;
	uGC_e1monitor = gClient->GetGC(&vale1monitor, kTRUE);

	entry_e1monitor = new TGNumberEntry(FrameEMonitor,
	(Double_t) 0,6,-1,(TGNumberFormat::EStyle) 5);
	entry_e1monitor->SetNumber(GetReadSCChannel1());
	FrameEMonitor->AddFrame(entry_e1monitor,
		new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
	entry_e1monitor->MoveResize(80,30,50,20);

	TGTextButton *Button_e1monitor = 
		new TGTextButton(FrameEMonitor,"config",-1,
		TGTextButton::GetDefaultGC()(),
		TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
	Button_e1monitor->MoveResize(132,30,50,20);
	Button_e1monitor->Connect("Clicked()",0,0,"SetReadSCChannel1()");



	//アナログoutput2　channel設定
	label = new TGLabel(FrameEMonitor,"channel(2):");
	label->SetTextJustify(36);
	label->SetMargins(0,0,0,0);
	label->SetWrapLength(-1);
	FrameEMonitor->AddFrame(label,
		new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
	label->MoveResize(8,50,70,20);

	TGFont*ufont_e2monitor;
	ufont_e2monitor = gClient->GetFont(
		"-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
	TGGC*uGC_e2monitor;
	GCValues_t vale2monitor;
	uGC_e2monitor = gClient->GetGC(&vale2monitor, kTRUE);

	entry_e2monitor = new TGNumberEntry(FrameEMonitor,
	(Double_t) 0,6,-1,(TGNumberFormat::EStyle) 5);
	entry_e2monitor->SetNumber(GetReadSCChannel2());
	FrameEMonitor->AddFrame(entry_e2monitor,
		new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
	entry_e2monitor->MoveResize(80,50,50,20);

	TGTextButton *Button_e2monitor = 
		new TGTextButton(FrameEMonitor,"config",-1,
		TGTextButton::GetDefaultGC()(),
		TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
	Button_e2monitor->MoveResize(132,50,50,20);
	Button_e2monitor->Connect("Clicked()",0,0,"SetReadSCChannel2()");

	//説明書き
	label_comment = new TGLabel(FrameEMonitor,
		" After the push button,\n aim to command '2' in easiroc.");
	FrameEMonitor->AddFrame(label_comment,
		new TGLayoutHints(kLHintsLeft |	kLHintsTop,2,2,2,2));
	label_comment->MoveResize(0,70,200,40);


	//Closeボタン
	TGTextButton *Button_CloseEM = new TGTextButton
		(FrameEMonitor,"close",-1,
		TGTextButton::GetDefaultGC()(),
		TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
	Button_CloseEM->MoveResize(320,120,70,20);
	Button_CloseEM->Connect("Clicked()",0,0,"CloseWinEASIROCMONITOR()");

	//フレームの調整
	FrameEMonitor->SetMWMHints(kMWMDecorAll,
                       kMWMFuncAll,
                       kMWMInputModeless);
	FrameEMonitor->MapSubwindows();
	FrameEMonitor->Resize(MainFrame->GetDefaultSize());
	FrameEMonitor->MapWindow();
	FrameEMonitor->Resize(400,150);
}


//ANALOG OUTPUT channel 1 config
int GetReadSCChannel1(){
	string line;
	int x;
	ifstream ifs("./setup/ReadSC_Channel1.txt");
	for(int i=0;i<7;i++) getline(ifs,line);
	for(int i=0;i<3;i++) ifs>>line;
	for(int i=0;i<32;i++){
		ifs>>x;
		if(x==1) return i;}
	return 0;}
void SetReadSCChannel1(){
	string line;
	ifstream ifs("./setup/ReadSC_Channel1.txt");
	ofstream ofs("./setup/ReadSC_Channel1.txt~");
	for(int i=0;i<7;i++){
		getline(ifs,line);
		ofs<<line<<endl;}
	for(int i=0;i<3;i++){
		ifs>>line;
		ofs<<line<<" ";}
	for(int i=0;i<32;i++){
		if(i!=(int)entry_e1monitor->GetNumber())ofs<<0<<" ";
		else ofs<<1<<" ";}
	ofs.close();
	system("cp ./setup/ReadSC_Channel1.txt~ ./setup/ReadSC_Channel1.txt");}


//ANALOG OUTPUT channel 2 config
int GetReadSCChannel2(){
	string line;
	int x;
	ifstream ifs("./setup/ReadSC_Channel2.txt");
	for(int i=0;i<7;i++) getline(ifs,line);
	for(int i=0;i<3;i++) ifs>>line;
	for(int i=0;i<32;i++){
		ifs>>x;
		if(x==1) return i;}
	return 0;}
void SetReadSCChannel2(){
	string line;
	ifstream ifs("./setup/ReadSC_Channel2.txt");
	ofstream ofs("./setup/ReadSC_Channel2.txt~");
	for(int i=0;i<7;i++){
		getline(ifs,line);
		ofs<<line<<endl;}
	for(int i=0;i<3;i++){
		ifs>>line;
		ofs<<line<<" ";}
	for(int i=0;i<32;i++){
		if(i!=(int)entry_e2monitor->GetNumber())ofs<<0<<" ";
		else ofs<<1<<" ";}
	ofs.close();
	system("cp ./setup/ReadSC_Channel2.txt~ ./setup/ReadSC_Channel2.txt");}


//フレームClose
void CloseWinEASIROCMONITOR(){
cout<<"close\n";
FrameEMonitor->CloseWindow();}




/*void monitor_hist~(){
char name[100],cmd[100];
double x;
sprintf(name,"ls %sdata | grep %05d > ./setup/MonitorFile.txt",entry->GetText(),(int)(entry_monitor->GetNumber()));
system(name);

ifstream ifs("./setup/MonitorFile.txt");
ifs>>cmd;
ifs.close();
sprintf(name,"%sdata/%s",entry->GetText(),cmd);
ifstream ifs(name);

adc[16]=new TH1S();
for(int i=0;i<16;i++){
	sprintf(name,"adc%d",i);
	adc[i]=new TH1S(name,name,4096,0,4096);}
tdc[8] =new TH1S();
for(int i=0;i<8;i++){
	sprintf(name,"tdc%d",i);
	tdc[i]=new TH1S(name,name,4096,0,4096);}

int j=0;
while(!ifs.eof()){
	j++;
	for(int i=0;i<16;i++){
		ifs>>x;
		adc[i]->Fill(x);}
	for(int i=0;i<8;i++){
		ifs>>x;
		tdc[i]->Fill(x);}
	if(j%100==0)cout<<"."<<flush;}
ifs.close();
	
canv[10]=new TCanvas();
for(int j=0;j<4;j++){
	sprintf(name,"canv%d",j);
	canv[j]=new TCanvas(name);
	canv[j]->Divide(4,4);
	for(int i=0;i<4;i++){
		canv[j]->cd(i+1);
		adc[i+j*4]->Draw();
		cout<<i<<"\n";}}

for(int j=0;j<2;j++){
	sprintf(name,"canv%d",j+4);
	canv[j+4]=new TCanvas(name);
	canv[j+4]->Divide(4,4);
	for(int i=0;i<4;i++){
		canv[j+4]->cd(i+1);
		tdc[i+j*4]->Draw();
		cout<<i<<"\n";}}
}*/



